Index: kernel/arch/sparc64/src/mm/sun4u/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4u/tlb.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/mm/sun4u/tlb.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup sparc64mm	
+/** @addtogroup sparc64mm
  * @{
  */
@@ -58,5 +58,6 @@
 static void dtlb_pte_copy(pte_t *, size_t, bool);
 static void itlb_pte_copy(pte_t *, size_t);
-static void do_fast_instruction_access_mmu_miss_fault(istate_t *, const char *);
+static void do_fast_instruction_access_mmu_miss_fault(istate_t *, uintptr_t,
+    const char *);
 static void do_fast_data_access_mmu_miss_fault(istate_t *, tlb_tag_access_reg_t,
     const char *);
@@ -222,10 +223,10 @@
 		 * Forward the page fault to the address space page fault
 		 * handler.
-		 */		
+		 */
 		page_table_unlock(AS, true);
 		if (as_page_fault(page_16k, PF_ACCESS_EXEC, istate) ==
 		    AS_PF_FAULT) {
 			do_fast_instruction_access_mmu_miss_fault(istate,
-			    __func__);
+			    istate->tpc, __func__);
 		}
 	}
@@ -258,5 +259,5 @@
 			/* NULL access in kernel */
 			do_fast_data_access_mmu_miss_fault(istate, tag,
-			    __func__);
+			    "Dereferencing NULL pointer.");
 		} else if (page_8k >= end_of_identity) {
 			/*
@@ -438,9 +439,8 @@
 
 void do_fast_instruction_access_mmu_miss_fault(istate_t *istate,
-    const char *str)
-{
-	fault_if_from_uspace(istate, "%s.", str);
-	dump_istate(istate);
-	panic("%s.", str);
+    uintptr_t va, const char *str)
+{
+	fault_if_from_uspace(istate, "%s, Address=%p.", str, va);
+	panic_memtrap(istate, PF_ACCESS_EXEC, va, str);
 }
 
@@ -451,11 +451,7 @@
 
 	va = tag.vpn << MMU_PAGE_WIDTH;
-	if (tag.context) {
-		fault_if_from_uspace(istate, "%s, Page=%p (ASID=%d).", str, va,
-		    tag.context);
-	}
-	dump_istate(istate);
-	printf("Faulting page: %p, ASID=%d.\n", va, tag.context);
-	panic("%s.", str);
+	fault_if_from_uspace(istate, "%s, Page=%p (ASID=%d).", str, va,
+	    tag.context);
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, va, str);
 }
 
@@ -466,12 +462,7 @@
 
 	va = tag.vpn << MMU_PAGE_WIDTH;
-
-	if (tag.context) {
-		fault_if_from_uspace(istate, "%s, Page=%p (ASID=%d).", str, va,
-		    tag.context);
-	}
-	printf("Faulting page: %p, ASID=%d\n", va, tag.context);
-	dump_istate(istate);
-	panic("%s.", str);
+	fault_if_from_uspace(istate, "%s, Page=%p (ASID=%d).", str, va,
+	    tag.context);
+	panic_memtrap(istate, PF_ACCESS_WRITE, va, str);
 }
 
Index: kernel/arch/sparc64/src/mm/sun4v/as.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/as.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/mm/sun4v/as.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -44,4 +44,5 @@
 
 #ifdef CONFIG_TSB
+
 #include <arch/mm/tsb.h>
 #include <arch/memstr.h>
@@ -50,4 +51,5 @@
 #include <bitops.h>
 #include <macros.h>
+
 #endif /* CONFIG_TSB */
 
@@ -61,15 +63,15 @@
 }
 
-int as_constructor_arch(as_t *as, int flags)
+int as_constructor_arch(as_t *as, unsigned int flags)
 {
 #ifdef CONFIG_TSB
-	int order = fnzb32(
+	uint8_t order = fnzb32(
 		(TSB_ENTRY_COUNT * sizeof(tsb_entry_t)) >> FRAME_WIDTH);
-
+	
 	uintptr_t tsb = (uintptr_t) frame_alloc(order, flags);
-
+	
 	if (!tsb)
 		return -1;
-
+	
 	as->arch.tsb_description.page_size = PAGESIZE_8K;
 	as->arch.tsb_description.associativity = 1;
@@ -79,8 +81,9 @@
 	as->arch.tsb_description.reserved = 0;
 	as->arch.tsb_description.context = 0;
-
+	
 	memsetb((void *) PA2KA(as->arch.tsb_description.tsb_base),
 		TSB_ENTRY_COUNT * sizeof(tsb_entry_t), 0);
 #endif
+	
 	return 0;
 }
@@ -91,4 +94,5 @@
 	size_t cnt = (TSB_ENTRY_COUNT * sizeof(tsb_entry_t)) >> FRAME_WIDTH;
 	frame_free((uintptr_t) as->arch.tsb_description.tsb_base);
+	
 	return cnt;
 #else
@@ -97,9 +101,10 @@
 }
 
-int as_create_arch(as_t *as, int flags)
+int as_create_arch(as_t *as, unsigned int flags)
 {
 #ifdef CONFIG_TSB
 	tsb_invalidate(as, 0, (size_t) -1);
 #endif
+	
 	return 0;
 }
@@ -111,14 +116,16 @@
  *
  * @param as Address space.
+ *
  */
 void as_install_arch(as_t *as)
 {
 	mmu_secondary_context_write(as->asid);
-#ifdef CONFIG_TSB	
+	
+#ifdef CONFIG_TSB
 	uintptr_t base = ALIGN_DOWN(config.base, 1 << KERNEL_PAGE_WIDTH);
-
+	
 	ASSERT(as->arch.tsb_description.tsb_base);
 	uintptr_t tsb = PA2KA(as->arch.tsb_description.tsb_base);
-		
+	
 	if (!overlaps(tsb, 8 * MMU_PAGE_SIZE, base, 1 << KERNEL_PAGE_WIDTH)) {
 		/*
@@ -126,11 +133,11 @@
 		 * by the locked 4M kernel DTLB entry. We need
 		 * to map both TSBs explicitly.
+		 *
 		 */
 		mmu_demap_page(tsb, 0, MMU_FLAG_DTLB);
 		dtlb_insert_mapping(tsb, KA2PA(tsb), PAGESIZE_64K, true, true);
 	}
-
+	
 	__hypercall_fast2(MMU_TSB_CTXNON0, 1, KA2PA(&(as->arch.tsb_description)));
-	
 #endif
 }
@@ -142,8 +149,8 @@
  *
  * @param as Address space.
+ *
  */
 void as_deinstall_arch(as_t *as)
 {
-
 	/*
 	 * Note that we don't and may not lock the address space. That's ok
@@ -151,13 +158,14 @@
 	 *
 	 * Moreover, the as->asid is protected by asidlock, which is being held.
+	 *
 	 */
-
+	
 #ifdef CONFIG_TSB
 	uintptr_t base = ALIGN_DOWN(config.base, 1 << KERNEL_PAGE_WIDTH);
-
+	
 	ASSERT(as->arch.tsb_description.tsb_base);
-
+	
 	uintptr_t tsb = PA2KA(as->arch.tsb_description.tsb_base);
-		
+	
 	if (!overlaps(tsb, 8 * MMU_PAGE_SIZE, base, 1 << KERNEL_PAGE_WIDTH)) {
 		/*
@@ -165,4 +173,5 @@
 		 * by the locked 4M kernel DTLB entry. We need
 		 * to demap the entry installed by as_install_arch().
+		 *
 		 */
 		__hypercall_fast3(MMU_UNMAP_PERM_ADDR, tsb, 0, MMU_FLAG_DTLB);
Index: kernel/arch/sparc64/src/mm/sun4v/frame.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/frame.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/mm/sun4v/frame.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -47,25 +47,28 @@
 void frame_arch_init(void)
 {
-	unsigned int i;
-	pfn_t confdata;
-
 	if (config.cpu_active == 1) {
+		unsigned int i;
+		
 		for (i = 0; i < memmap.cnt; i++) {
-			uintptr_t start = (uintptr_t) memmap.zones[i].start;
-			size_t size = memmap.zones[i].size;
-
+			/* To be safe, make the available zone possibly smaller */
+			uintptr_t new_start = ALIGN_UP((uintptr_t) memmap.zones[i].start,
+			    FRAME_SIZE);
+			size_t new_size = ALIGN_DOWN(memmap.zones[i].size -
+			    (new_start - ((uintptr_t) memmap.zones[i].start)), FRAME_SIZE);
+			
 			/*
 			 * The memmap is created by HelenOS boot loader.
 			 * It already contains no holes.
 			 */
-
-			confdata = ADDR2PFN(start);
+			
+			pfn_t confdata = ADDR2PFN(new_start);
+			
 			if (confdata == ADDR2PFN(KA2PA(PFN2ADDR(0))))
 				confdata = ADDR2PFN(KA2PA(PFN2ADDR(2)));
-			zone_create(ADDR2PFN(start),
-			    SIZE2FRAMES(ALIGN_DOWN(size, FRAME_SIZE)),
+			
+			zone_create(ADDR2PFN(new_start), SIZE2FRAMES(new_size),
 			    confdata, 0);
 		}
-
+		
 		/*
 		 * On sparc64, physical memory can start on a non-zero address.
Index: kernel/arch/sparc64/src/mm/sun4v/tlb.c
===================================================================
--- kernel/arch/sparc64/src/mm/sun4v/tlb.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/mm/sun4v/tlb.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup sparc64mm	
+/** @addtogroup sparc64mm
  * @{
  */
@@ -62,5 +62,6 @@
 static void itlb_pte_copy(pte_t *);
 static void dtlb_pte_copy(pte_t *, bool);
-static void do_fast_instruction_access_mmu_miss_fault(istate_t *, const char *);
+static void do_fast_instruction_access_mmu_miss_fault(istate_t *, uintptr_t,
+    const char *);
 static void do_fast_data_access_mmu_miss_fault(istate_t *, uint64_t,
     const char *);
@@ -235,9 +236,9 @@
 		 * Forward the page fault to the address space page fault
 		 * handler.
-		 */		
+		 */
 		page_table_unlock(AS, true);
 		if (as_page_fault(va, PF_ACCESS_EXEC, istate) == AS_PF_FAULT) {
 			do_fast_instruction_access_mmu_miss_fault(istate,
-			    __func__);
+			    istate->tpc, __func__);
 		}
 	}
@@ -354,10 +355,9 @@
 }
 
-void do_fast_instruction_access_mmu_miss_fault(istate_t *istate,
+void do_fast_instruction_access_mmu_miss_fault(istate_t *istate, uintptr_t va,
     const char *str)
 {
-	fault_if_from_uspace(istate, "%s.", str);
-	dump_istate(istate);
-	panic("%s.", str);
+	fault_if_from_uspace(istate, "%s, Address=%p.", str, va);
+	panic_memtrap(istate, PF_ACCESS_EXEC, va, str);
 }
 
@@ -365,11 +365,8 @@
     uint64_t page_and_ctx, const char *str)
 {
-	if (DMISS_CONTEXT(page_and_ctx)) {
-		fault_if_from_uspace(istate, "%s, Page=%p (ASID=%d)\n", str, DMISS_ADDRESS(page_and_ctx),
-		    DMISS_CONTEXT(page_and_ctx));
-	}
-	dump_istate(istate);
-	printf("Faulting page: %p, ASID=%d\n", DMISS_ADDRESS(page_and_ctx), DMISS_CONTEXT(page_and_ctx));
-	panic("%s\n", str);
+	fault_if_from_uspace(istate, "%s, Page=%p (ASID=%d).", str,
+	    DMISS_ADDRESS(page_and_ctx), DMISS_CONTEXT(page_and_ctx));
+	panic_memtrap(istate, PF_ACCESS_UNKNOWN, DMISS_ADDRESS(page_and_ctx),
+	    str);
 }
 
@@ -377,11 +374,8 @@
     uint64_t page_and_ctx, const char *str)
 {
-	if (DMISS_CONTEXT(page_and_ctx)) {
-		fault_if_from_uspace(istate, "%s, Page=%p (ASID=%d)\n", str, DMISS_ADDRESS(page_and_ctx),
-		    DMISS_CONTEXT(page_and_ctx));
-	}
-	printf("Faulting page: %p, ASID=%d\n", DMISS_ADDRESS(page_and_ctx), DMISS_CONTEXT(page_and_ctx));
-	dump_istate(istate);
-	panic("%s\n", str);
+	fault_if_from_uspace(istate, "%s, Page=%p (ASID=%d).", str,
+	    DMISS_ADDRESS(page_and_ctx), DMISS_CONTEXT(page_and_ctx));
+	panic_memtrap(istate, PF_ACCESS_WRITE, DMISS_ADDRESS(page_and_ctx),
+	    str);
 }
 
Index: kernel/arch/sparc64/src/smp/sun4v/smp.c
===================================================================
--- kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/smp/sun4v/smp.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup sparc64	
+/** @addtogroup sparc64
  * @{
  */
@@ -292,5 +292,5 @@
 				exec_units[i].strand_count = 0;
 				atomic_set(&(exec_units[i].nrdy), 0);
-				spinlock_initialize(&(exec_units[i].proposed_nrdy_lock), "proposed nrdy lock");
+				spinlock_initialize(&(exec_units[i].proposed_nrdy_lock), "exec_units[].proposed_nrdy_lock");
 				exec_unit_count++;
 			}
@@ -330,5 +330,5 @@
 		exec_units[0].strand_count = cpu_count;
 		exec_units[0].exec_unit_id = 1;
-		spinlock_initialize(&(exec_units[0].proposed_nrdy_lock), "proposed nrdy lock");
+		spinlock_initialize(&(exec_units[0].proposed_nrdy_lock), "exec_units[0].proposed_nrdy_lock");
 		atomic_set(&(exec_units[0].nrdy), 0);
 		max_core_strands = cpu_count;
Index: kernel/arch/sparc64/src/sun4u/asm.S
===================================================================
--- kernel/arch/sparc64/src/sun4u/asm.S	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/sun4u/asm.S	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -67,4 +67,8 @@
 	WRITE_ALTERNATE_REGISTER %g6, PSTATE_IG_BIT
 
+.global read_from_ag_g6
+read_from_ag_g6:
+	READ_ALTERNATE_REGISTER %g6, PSTATE_AG_BIT
+
 .global read_from_ag_g7
 read_from_ag_g7:
Index: kernel/arch/sparc64/src/sun4u/start.S
===================================================================
--- kernel/arch/sparc64/src/sun4u/start.S	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/sun4u/start.S	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -293,8 +293,14 @@
 	 * Call arch_pre_main(bootinfo)
 	 */
+	call arch_pre_main
 	mov %o1, %o0
-	call arch_pre_main
-	nop
-	
+	
+	/*
+	 * Create the first stack frame.
+	 */
+	save %sp, -(STACK_WINDOW_SAVE_AREA_SIZE + STACK_ARG_SAVE_AREA_SIZE), %sp
+	flushw
+	add %g0, -STACK_BIAS, %fp
+
 	call main_bsp
 	nop
@@ -303,6 +309,5 @@
 
 0:
-	ba %xcc, 0b
-	nop
+	ba,a %xcc, 0b
 
 
@@ -354,4 +359,11 @@
 	ldx [%g1], %o6
 
+	/*
+	 * Create the first stack frame.
+	 */
+	save %sp, -(STACK_WINDOW_SAVE_AREA_SIZE + STACK_ARG_SAVE_AREA_SIZE), %sp
+	flushw
+	add %g0, -STACK_BIAS, %fp
+
 	call main_ap
 	nop
@@ -361,6 +373,5 @@
 	
 0:
-	ba %xcc, 0b
-	nop
+	ba,a %xcc, 0b
 
 
Index: kernel/arch/sparc64/src/sun4v/start.S
===================================================================
--- kernel/arch/sparc64/src/sun4v/start.S	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/sun4v/start.S	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -155,5 +155,4 @@
    	mov 0, %o5
    	ta 0xff
-   	nop
 
 	/*
@@ -219,5 +218,5 @@
 	! on APs skip executing the following code
 	cmp %l7, 0
-	be 1f
+	be %xcc, 1f
 	nop
 
@@ -250,8 +249,14 @@
 	 * Call arch_pre_main(bootinfo)
 	 */
+	call arch_pre_main
 	or %l1, %g0, %o0
-	call arch_pre_main
-	nop
 	
+	/*
+	 * Create the first stack frame.
+	 */
+	save %sp, -(STACK_WINDOW_SAVE_AREA_SIZE + STACK_ARG_SAVE_AREA_SIZE), %sp
+	flushw
+	add %g0, -STACK_BIAS, %fp
+
 	call main_bsp
 	nop
@@ -260,6 +265,5 @@
 
 0:
-	ba 0b
-	nop
+	ba,a %xcc, 0b
 
 1:
@@ -273,8 +277,8 @@
 	 */
 
-	mov	1, %o0			! MMU enable flag
-	set	mmu_enabled, %o1
-	mov	MMU_ENABLE, %o5	! MMU enable HV call
-	ta	0x80		! call HV
+	mov 1, %o0		! MMU enable flag
+	set mmu_enabled, %o1
+	mov MMU_ENABLE, %o5	! MMU enable HV call
+	ta 0x80			! call HV
 
 	mmu_enabled:
@@ -289,4 +293,11 @@
 	ldx [%g1], %o6
 
+	/*
+	 * Create the first stack frame.
+	 */
+	save %sp, -(STACK_WINDWO_SAVE_AREA_SIZE + STACK_ARG_SAVE_AREA_SIZE), %sp
+	flushw
+	add %g0, -STACK_BIAS, %fp
+
 	call main_ap
 	nop
@@ -295,6 +306,5 @@
 	/* Not reached. */
 0:
-	ba 0b
-	nop
+	ba,a %xcc, 0b
 
 .align 8
@@ -314,6 +324,5 @@
 before_ap_boots:
 	setx 0x80400000, %g0, %o0
-	ba kernel_image_start
-	nop
+	ba,a %xcc, kernel_image_start
 
 .section K_DATA_START, "aw", @progbits
Index: kernel/arch/sparc64/src/trap/exception.c
===================================================================
--- kernel/arch/sparc64/src/trap/exception.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/trap/exception.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -44,5 +44,5 @@
 #include <symtab.h>
 
-void dump_istate(istate_t *istate)
+void istate_decode(istate_t *istate)
 {
 	const char *tpcs = symtab_fmt_name_lookup(istate->tpc);
@@ -58,6 +58,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -66,6 +65,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -74,6 +72,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -82,6 +79,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -90,6 +86,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -98,6 +93,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -118,6 +112,5 @@
 #else
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 #endif
 }
@@ -127,6 +120,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -135,6 +127,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -143,6 +134,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -151,6 +141,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -159,7 +148,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	describe_dmmu_fault();
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -168,6 +155,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -176,6 +162,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -184,6 +169,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -192,6 +176,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -200,6 +183,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -208,6 +190,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
@@ -216,6 +197,5 @@
 {
 	fault_if_from_uspace(istate, "%s.", __func__);
-	dump_istate(istate);
-	panic("%s.", __func__);
+	panic_badtrap(istate, n, "%s.", __func__);
 }
 
Index: kernel/arch/sparc64/src/trap/interrupt.c
===================================================================
--- kernel/arch/sparc64/src/trap/interrupt.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/trap/interrupt.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -51,14 +51,17 @@
 /** Register Interrupt Level Handler.
  *
- * @param n Interrupt Level (1 - 15).
- * @param name Short descriptive string.
- * @param f Handler.
+ * @param n       Interrupt Level (1 - 15).
+ * @param name    Short descriptive string.
+ * @param handler Handler.
+ *
  */
-void interrupt_register(int n, const char *name, iroutine f)
+void interrupt_register(unsigned int n, const char *name, iroutine_t handler)
 {
-	ASSERT(n >= IVT_FIRST && n <= IVT_ITEMS);
+	ASSERT(n >= IVT_FIRST);
+	ASSERT(n <= IVT_ITEMS);
 	
-	exc_register(n - 1, name, f);
+	exc_register(n - IVT_FIRST, name, true, handler);
 }
+
 /** @}
  */
Index: kernel/arch/sparc64/src/trap/sun4u/interrupt.c
===================================================================
--- kernel/arch/sparc64/src/trap/sun4u/interrupt.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/trap/sun4u/interrupt.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -55,18 +55,15 @@
 void interrupt(int n, istate_t *istate)
 {
-	uint64_t status;
-	uint64_t intrcv;
-	uint64_t data0;
-	status = asi_u64_read(ASI_INTR_DISPATCH_STATUS, 0);
+	uint64_t status = asi_u64_read(ASI_INTR_DISPATCH_STATUS, 0);
 	if (status & (!INTR_DISPATCH_STATUS_BUSY))
 		panic("Interrupt Dispatch Status busy bit not set\n");
-
-	intrcv = asi_u64_read(ASI_INTR_RECEIVE, 0);
+	
+	uint64_t intrcv = asi_u64_read(ASI_INTR_RECEIVE, 0);
 #if defined (US)
-	data0 = asi_u64_read(ASI_INTR_R, ASI_UDB_INTR_R_DATA_0);
+	uint64_t data0 = asi_u64_read(ASI_INTR_R, ASI_UDB_INTR_R_DATA_0);
 #elif defined (US3)
-	data0 = asi_u64_read(ASI_INTR_R, VA_INTR_R_DATA_0);
+	uint64_t data0 = asi_u64_read(ASI_INTR_R, VA_INTR_R_DATA_0);
 #endif
-
+	
 	irq_t *irq = irq_dispatch_and_lock(data0);
 	if (irq) {
@@ -75,11 +72,12 @@
 		 */
 		irq->handler(irq);
+		
 		/*
 		 * See if there is a clear-interrupt-routine and call it.
 		 */
-		if (irq->cir) {
+		if (irq->cir)
 			irq->cir(irq->cir_arg, irq->inr);
-		}
-		spinlock_unlock(&irq->lock);
+		
+		irq_spinlock_unlock(&irq->lock, false);
 	} else if (data0 > config.base) {
 		/*
@@ -90,7 +88,6 @@
 		 */
 #ifdef CONFIG_SMP
-		if (data0 == (uintptr_t) tlb_shootdown_ipi_recv) {
+		if (data0 == (uintptr_t) tlb_shootdown_ipi_recv)
 			tlb_shootdown_ipi_recv();
-		}
 #endif
 	} else {
@@ -101,7 +98,9 @@
 		printf("cpu%u: spurious interrupt (intrcv=%#" PRIx64
 		    ", data0=%#" PRIx64 ")\n", CPU->id, intrcv, data0);
+#else
+		(void) intrcv;
 #endif
 	}
-
+	
 	membar();
 	asi_u64_write(ASI_INTR_RECEIVE, 0, 0);
Index: kernel/arch/sparc64/src/trap/sun4u/trap_table.S
===================================================================
--- kernel/arch/sparc64/src/trap/sun4u/trap_table.S	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/trap/sun4u/trap_table.S	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -481,6 +481,6 @@
 	be %xcc, 1f
 	nop
-0:	ba %xcc, 0b				! this is for debugging, if we ever get here
-	nop					! it will be easy to find
+	! this is for debugging, if we ever get here it will be easy to find
+0:	ba,a %xcc, 0b
 
 1:
@@ -546,6 +546,5 @@
 
 .if NOT(\is_syscall)
-	ba %xcc, 1f
-	nop
+	ba,a %xcc, 1f
 0:
 	save %sp, -PREEMPTIBLE_HANDLER_STACK_FRAME_SIZE, %sp
Index: kernel/arch/sparc64/src/trap/sun4v/interrupt.c
===================================================================
--- kernel/arch/sparc64/src/trap/sun4v/interrupt.c	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/trap/sun4v/interrupt.c	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -111,5 +111,5 @@
 			((void (*)(void)) data1)();
 		} else {
-			printf("Spurious interrupt on %d, data = %lx.\n",
+			printf("Spurious interrupt on %d, data = %" PRIx64 ".\n",
 			    CPU->arch.id, data1);
 		}
Index: kernel/arch/sparc64/src/trap/sun4v/trap_table.S
===================================================================
--- kernel/arch/sparc64/src/trap/sun4v/trap_table.S	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/arch/sparc64/src/trap/sun4v/trap_table.S	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -71,6 +71,5 @@
 .org trap_table + TT_INSTRUCTION_ACCESS_MMU_MISS*ENTRY_SIZE
 .global instruction_access_mmu_miss_handler_tl0
-	ba fast_instruction_access_mmu_miss_handler_tl0
-	nop
+	ba,a %xcc, fast_instruction_access_mmu_miss_handler_tl0
 
 /* TT = 0x0a, TL = 0, instruction_access_error */
@@ -187,6 +186,5 @@
 .global data_access_mmu_miss_tl0
 data_access_mmu_miss_tl0:
-	ba fast_data_access_mmu_miss_handler_tl0
-	nop
+	ba,a %xcc, fast_data_access_mmu_miss_handler_tl0
 
 /* TT = 0x32, TL = 0, data_access_error */
@@ -394,5 +392,5 @@
 .global trap_instruction_\cur\()_tl0
 trap_instruction_\cur\()_tl0:
-	ba trap_instruction_handler
+	ba %xcc, trap_instruction_handler
 	mov \cur, %g2
 .endr
@@ -414,6 +412,5 @@
 .global instruction_access_mmu_miss_handler_tl1
 	wrpr %g0, 1, %tl
-	ba fast_instruction_access_mmu_miss_handler_tl0
-	nop
+	ba,a %xcc, fast_instruction_access_mmu_miss_handler_tl0
 
 /* TT = 0x0a, TL > 0, instruction_access_error */
@@ -498,7 +495,5 @@
 .global data_access_mmu_miss_tl1
 data_access_mmu_miss_tl1:
-	ba fast_data_access_mmu_miss_handler_tl1
-	nop
-
+	ba,a %xcc, fast_data_access_mmu_miss_handler_tl1
 
 /* TT = 0x32, TL > 0, data_access_error */
@@ -742,5 +737,5 @@
 	rdpr %cwp, %l1
 	cmp %l0, %l1
-	bz 4f				! CWP is ok
+	bz %xcc, 4f			! CWP is ok
 	nop
 
@@ -785,8 +780,9 @@
 	rdpr %tl, %g3
 	cmp %g3, 1
-	be 1f
+	be %xcc, 1f
 	nop
-0:	ba 0b					! this is for debugging, if we ever get here
-	nop					! it will be easy to find
+
+	! this is for debugging, if we ever get here it will be easy to find
+0:	ba,a %xcc, 0b
 
 1:
@@ -957,5 +953,5 @@
 	clr %g4
 5:	andcc %g7, UWB_ALIGNMENT - 1, %g0	! alignment check
-	bz 6f					! %g7 is UWB_ALIGNMENT-aligned, no more windows to refill
+	bz %xcc, 6f				! %g7 is UWB_ALIGNMENT-aligned, no more windows to refill
 	nop
 
@@ -982,5 +978,5 @@
 	wrpr %g3, 0, %cwp			! switch to the preceeding window
 
-	ba 5b
+	ba %xcc, 5b
 	inc %g4
 
@@ -996,5 +992,5 @@
 	add %g4, %g2, %g2
 	cmp %g2, NWINDOWS - 2
-	bg 8f					! fix the CANRESTORE=NWINDOWS-1 anomaly
+	bg %xcc, 8f				! fix the CANRESTORE=NWINDOWS-1 anomaly
 	mov NWINDOWS - 2, %g1			! use dealy slot for both cases
 	sub %g1, %g2, %g1
@@ -1066,6 +1062,5 @@
 
 	PREEMPTIBLE_HANDLER_KERNEL
-	ba 101f
-	nop
+	ba,a %xcc, 101f
 
 	100:
Index: kernel/doc/synchronization
===================================================================
--- kernel/doc/synchronization	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/doc/synchronization	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -5,4 +5,14 @@
                                  | spinlock_t |
                                  +------------+
+                                       |
+                                       +------------------------------+
+                                                                      |
+                      INTERRUPTS-DISABLED SPINNING LOCKS              |
+       irq_spinlock_lock, irq_spinlock_trylock, irq_spinlock_unlock   |
+                               +----------------+                     |
+                               | irq_spinlock_t |<--------------------+
+                               +----------------+
+
+
 
                                    WAIT QUEUES
@@ -10,6 +20,6 @@
                                    +---------+
                                    | waitq_t |
-			           +---------+
-				  /           \
+                                   +---------+
+                                  /           \
                SEMAPHORES        /             \  CONDITION VARIABLES
  semaphore_down_timeout, semaphore_up    condvar_wait_timeout, condvar_signal
@@ -18,12 +28,12 @@
             +--------------+                         +-----------+
                    |                                       ^
-		   |                                       |
+                   |                                       |
                    |                                +------+
-                   V                               /           
+                   V                               /
                 MUTEXES                           / READERS/WRITERS LOCKS
     mutex_lock_timeout, mutex_unlock   rwlock_reader/writer_lock_timeout, rwlock_unlock
               +---------+                       /        +----------+
-	      | mutex_t |------------------------------->| rwlock_t |
-	      +---------+                     /          +----------+
-	           |                         /
-		   +------------------------+
+              | mutex_t |------------------------------->| rwlock_t |
+              +---------+                     /          +----------+
+                   |                         /
+                   +------------------------+
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/genarch/Makefile.inc	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -90,4 +90,14 @@
 endif
 
+ifeq ($(CONFIG_S3C24XX_IRQC),y)
+	GENARCH_SOURCES += \
+		genarch/src/drivers/s3c24xx_irqc/s3c24xx_irqc.c
+endif
+
+ifeq ($(CONFIG_S3C24XX_UART),y)
+	GENARCH_SOURCES += \
+		genarch/src/drivers/s3c24xx_uart/s3c24xx_uart.c
+endif
+
 ifeq ($(CONFIG_Z8530),y)
 	GENARCH_SOURCES += \
Index: kernel/genarch/include/acpi/acpi.h
===================================================================
--- kernel/genarch/include/acpi/acpi.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/genarch/include/acpi/acpi.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genarch	
+/** @addtogroup genarch
  * @{
  */
@@ -62,5 +62,5 @@
 	uint32_t creator_id;
 	uint32_t creator_revision;
-} __attribute__ ((packed));;
+} __attribute__ ((packed));
 
 struct acpi_signature_map {
@@ -74,5 +74,5 @@
 	struct acpi_sdt_header header;
 	uint32_t entry[];
-} __attribute__ ((packed));;
+} __attribute__ ((packed));
 
 /* Extended System Description Table */
@@ -80,5 +80,5 @@
 	struct acpi_sdt_header header;
 	uint64_t entry[];
-} __attribute__ ((packed));;
+} __attribute__ ((packed));
 
 extern struct acpi_rsdp *acpi_rsdp;
Index: kernel/genarch/include/drivers/pl050/pl050.h
===================================================================
--- kernel/genarch/include/drivers/pl050/pl050.h	(revision a6e54c5db4014406256cc9e1682c3c4771222aef)
+++ kernel/genarch/include/drivers/pl050/pl050.h	(revision 04cb68f2d06da3440e206ec4339c4d23afa3910a)
@@ -72,5 +72,5 @@
 #define PL050_STAT_RXFULL	(1 << 4)	/* 1: register Full */
 #define PL050_STAT_RXBUSY	(1 << 3)	/* 1: Busy, recieving Data */
-#define PL050_STAT_RXPARITY	(1 << 2)	/* odd parity of the last bit recieved */
+#define PL050_STAT_RXPARITY	(1 << 2)	/* odd parity of the last bit received */
 #define PL050_STAT_KMIC		(1 << 1)	/* status of KMICLKIN */
 #define PL050_STAT_KMID		1		/* status of KMIDATAIN */
